module Ruboty
  module Handlers
    class Gcal < Base
      on(
        /recent/,
        name: "recent",
        description: "List recent events"
      )

      on(
        /today/,
        name: "today",
        description: "List today's events"
      )

      on(
        /schedule\? (?<query>.+)/,
        name: "find",
        description: "Find a event"
      )

      on(
        /schedule "(?<title>.+)" from "(?<start_time>.+)" to "(?<end_time>.+)"/,
        name: "schedule",
        description: "Create a event"
      )

      on(
        /unschedule (?<event_id>.+)/,
        name: "unschedule",
        description: "Delete a event"
      )

      def recent(message)
        message.reply(calendar.recent)
      end

      def today(message)
        message.reply(calendar.today)
      end

      def find(message)
        calendar.find(message)
      end

      def schedule(message)
        calendar.schedule(message)
      end

      def unschedule(message)
        calendar.unschedule(message)
      end

      private

      def calendar
        Ruboty::Gcal::Calendar.new
      end
    end
  end
end
